import React from 'react';
interface GlyphObject {
    [glyph: string]: SVGR.Component;
}
export declare const Size: {
    readonly Small: "small";
    readonly Default: "default";
    readonly Large: "large";
    readonly XLarge: "xlarge";
};
export declare type Size = typeof Size[keyof typeof Size];
export interface IconProps<G extends GlyphObject> extends Omit<SVGR.ComponentProps, 'size'> {
    glyph: keyof G;
    size?: number | Size;
}
export default function createIconComponent<G extends GlyphObject>(glyphs: G): React.ComponentType<IconProps<G>>;
export {};
