var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useMemo } from 'react';
import PropTypes from 'prop-types';
import { cx, css } from '@leafygreen-ui/emotion';
import hljs from 'highlight.js/lib/highlight';
import hljsDefineGraphQL from 'highlightjs-graphql';
import { Variant, SupportedLanguages, Language } from './types';
import { injectGlobalStyles } from './globalStyles';
var syntaxHighlightingInitialized = false;
function filterSupportedLanguages(language) {
    return language !== 'csharp';
}
function initializeSyntaxHighlighting() {
    syntaxHighlightingInitialized = true;
    injectGlobalStyles();
    // We filter out 'csharp' here because it's redundant with 'cs'
    var SupportedLanguagesList = Object.values(SupportedLanguages).filter(filterSupportedLanguages);
    SupportedLanguagesList.forEach(function (language) {
        if (language === 'graphql') {
            hljsDefineGraphQL(hljs);
        }
        else {
            hljs.registerLanguage(language, require("highlight.js/lib/languages/" + language));
        }
    });
    hljs.configure({
        languages: SupportedLanguagesList,
        classPrefix: 'lg-highlight-',
        tabReplace: '  ',
    });
}
function Syntax(_a) {
    var _b;
    var children = _a.children, _c = _a.language, language = _c === void 0 ? Language.Auto : _c, className = _a.className, _d = _a.variant, variant = _d === void 0 ? Variant.Light : _d, rest = __rest(_a, ["children", "language", "className", "variant"]);
    if (!syntaxHighlightingInitialized) {
        initializeSyntaxHighlighting();
    }
    var codeClassName = cx("lg-highlight-hljs-" + variant, css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      color: inherit;\n      font-size: 13px;\n      line-height: 24px;\n    "], ["\n      color: inherit;\n      font-size: 13px;\n      line-height: 24px;\n    "]))), (_b = {},
        _b[language] = language !== Language.Auto,
        _b), className);
    if (language === Language.None) {
        return (React.createElement("code", __assign({}, rest, { className: codeClassName }), children));
    }
    var highlightedContent = useMemo(function () {
        if (language === Language.Auto) {
            return hljs.highlightAuto(children).value;
        }
        return hljs.highlight(language, children).value;
    }, [language, children]);
    // We use dangerouslySetInnerHTML here because the other Highlight.js API mutates the DOM
    // after rendering, and limits the flexibility to explicitly specify a language.
    return (React.createElement("code", __assign({}, rest, { className: codeClassName, dangerouslySetInnerHTML: { __html: highlightedContent } })));
}
Syntax.displayName = 'Syntax';
Syntax.propTypes = {
    children: PropTypes.string.isRequired,
    lang: PropTypes.oneOf(Object.values(Language)),
    className: PropTypes.string,
    variant: PropTypes.oneOf(Object.values(Variant)),
};
export default Syntax;
var templateObject_1;
//# sourceMappingURL=Syntax.js.map