import { TransformOptions } from '@babel/core';
export declare function babel(config: TransformOptions): {
    plugins: any[];
    ast?: boolean;
    auxiliaryCommentAfter?: string;
    auxiliaryCommentBefore?: string;
    root?: string;
    rootMode?: "root" | "upward" | "upward-optional";
    configFile?: string | false;
    babelrc?: boolean;
    babelrcRoots?: string | true | string[];
    envName?: string;
    code?: boolean;
    comments?: boolean;
    compact?: boolean | "auto";
    cwd?: string;
    caller?: import("@babel/core").TransformCaller;
    env?: {
        [index: string]: TransformOptions;
    };
    extends?: string;
    filename?: string;
    filenameRelative?: string;
    generatorOpts?: import("@babel/generator").GeneratorOptions;
    getModuleId?: (moduleName: string) => string;
    highlightCode?: boolean;
    ignore?: string[];
    inputSourceMap?: object;
    minified?: boolean;
    moduleId?: string;
    moduleIds?: boolean;
    moduleRoot?: string;
    only?: string | RegExp | (string | RegExp)[];
    parserOpts?: import("@babel/parser").ParserOptions;
    presets?: import("@babel/core").PluginItem[];
    retainLines?: boolean;
    shouldPrintComment?: (commentContents: string) => boolean;
    sourceFileName?: string;
    sourceMaps?: boolean | "inline" | "both";
    sourceRoot?: string;
    sourceType?: "script" | "module" | "unambiguous";
    wrapPluginVisitorMethod?: (pluginAlias: string, visitorType: "enter" | "exit", callback: (path: import("@babel/traverse").NodePath<import("@babel/types").Node>, state: any) => void) => (path: import("@babel/traverse").NodePath<import("@babel/types").Node>, state: any) => void;
};
